// naumann@stce.rwth-aachen.de

#pragma once

#include <vector> 
#include <limits>

#include "plotable.hpp"
#include "data.hpp"
#include "T.hpp"

/**
 * The model.
 */
class model : public plotable {
  const data& d;
  const T eps=std::numeric_limits<T>::epsilon();
  std::string filename;
  T mse() const; 
  T d_mse();
  T dd_mse();
protected:
  T p;
  model(const data&, char*);
  virtual ~model();
public:
  virtual T evaluate(T) const=0;
  void calibrate();
  void plot() const;
};
