// naumann@stce.rwth-aachen.de

#include <iostream> 
#include <cassert> 

#include "data.hpp"
#include "linear_model.hpp"
#include "nonlinear_model.hpp"

int main(int argc, char *argv[]) {
  assert(argc==3); 
  data d(argv[1]); nonlinear_model m(d,argv[2]); 
  double x,y;
  std::cout << "new observation:" << std::endl;
  std::cout << "x="; std::cin >> x;
  std::cout << "y="; std::cin >> y;
  d.add_observation(x,y);
  m.calibrate();
  std::cout << "new simulation:" << std::endl;
  std::cout << "x="; std::cin >> x;
  std::cout << "y=" << m.evaluate(x) << std::endl;
  d.plot(); m.plot();
  return 0;
}
