// naumann@stce.rwth-aachen.de

#pragma once

#include <vector> 
#include <limits>

#include "plotable.hpp"
#include "data.hpp"

/**
 * The model.
 */
template<typename T>
class model : public plotable {
  const data<T>& d;
  const T eps=std::numeric_limits<T>::epsilon();
  std::string filename;
  T mse() const; 
  T d_mse();
  T dd_mse();
protected:
  T p;
public:
  model(const data<T>&, char*);
  virtual ~model();
  virtual T evaluate(T) const=0;
  void calibrate();
  void plot() const;
};

#include "model.cpp"
